from typing import Iterable, Literal

source_label_dict = {
    "gmwnews": "Enlightenment Daily",
    "sina_news": "Sina News",
    "xueqiu": "Xueqiu (Snowball Finance)",
    "peoplenews": "People's Daily",
    "qnb": "China Youth Daily",
    "dagongdaily": "Ta Kung Pao",
    "xianggangwenhuidaily": "Wen Wei Po",
    "xinhuameiridaily": "Xinhua Daily",
    "local": "Local News",  # what is this
    "dazhongdaily": "Dazhong Daily",
    "yicai": "Yicai",
    "guizhoudaily": "Guizhou Daily",
    "hainandaily": "Hainan Daily",
    "fujiandaily": "Fujian Daily",
    "hubeidaily": "Hubei Daily",
    "zhongguoribaodaily": "China Daily",
    "hunandaily": "Hunan Daily",
    "guangmingdaily": "Enlightenment Daily",
    "ben": "Beijing Evening News",
    "xinmin": "Xinmin Evening News",
    "rmzxb": "CPPCC Daily",
    "zejiangdaily": "Zhejiang Daily",
    "gongrenribaodaily": "Workers' Daily",
    "jiangxidaily": "Jiangxi Daily",
    "sszn": "Shenzhen Special Zone Daily",
    "neimenggudaily": "Inner Mongolia Daily",
    "anhuidaily": "Anhui Daily",
    "sichuandaily": "Sichuan Daily",
    "jcrb": "Procuratorate Daily",
    "zhongguoqingniandaily": "China Youth News",
    "nongmindaily": "Farmers' Daily",
    "henandaily": "Henan Daily",
    "xinhuanet": "Xinhua News",
    "rmrbhwb": "People's Daily Overseas Edition",
    "bjd": "Beijing Daily",
    "szsb": "Shenzhen Economic Daily",
    "tianjindaily": "Tianjin Daily",
    "stdaily": "Science & Technology Daily",
    "xinjiangdaily": "Xinjiang Daily",
    "zhongguojiaoyudaily": "China Education Daily",
    "jfjbmap": "PLA Daily",
    "jilindaily": "Jilin Daily",
    "zhongguoxinxidaily": "China Information Daily",
    "OfficeOfTheCentralCyberspaceAffairsCommision": "Central Cyberspace Affairs Commission",
    "jjckb": "Economic Information Daily",
    "cicn": "China Market Regulation News",
    "renmingongandaily": "China Police Daily",
    "zhongguoshehuidaily": "China Society Daily",
    "zgshbnews": "China Society Daily",
    "cnfood": "China Food News",
    "central": "Central News",
    "laoningdaily": "Liaoning Daily",
    "ctn": "China Tourism News",
    "xinhuadaily": "Xinhua Daily",
    "ynetnews": "Beijing Youth Post",
    "xfrb": "Consumption Daily",
    "cpdnews": "China Police Daily",
    "comnews": "International Business Daily",
    "StateOwnedAssetsSupervisionAndAdministrationCommision": "State-Owned Assets Supervision and Administration Commission",
    "guangxidaily": "Guangxi Daily",
    "zhongguoxiaofeizhedaily": "China Consumer Journal",
    "heilongjiangdaily": "Heilongjiang Daily",
    "pcn": "People's Court Daily",
    "jingji": "21st Century Business Herald",
    "jiaotonganquanzhoukandaily": "Traffic Safety Weekly",
    "CommunistPartyOfChina": "Communist Party of China",
    "MinistryOfCultureAndTourism": "Ministry of Culture and Tourism",
    "cnii": "People's Post & Telecom",
    "bbtnews": "Beijing Business Today",
    "MinistryOfAgricultureAndRuralAffairs": "Ministry of Agriculture and Rural Affairs",
    "shfzb": "Shanghai Law Journal",
    "wenyibaodaily": "Literature and Art Newspaper",
    "StateCouncil": "State Council",
    "zhongguotiedaodaily": "People's Railway Post",
    "xizangdaily": "Tibet Daily",
    "zhongguoyingjiguanlidaily": "China Emergency Management News",
    "jiefangdaily": "Liberation Daily",
    "chongqingdaily": "Chongqing Daily",
    "cctv": "CCTV",
    "cb": "China Business Journal",
    "sciencenet": "China Science Daily",
    "zhongguoguofangdaily": "China National Defense News",
    "InstituteOfPartyHistoryAndLiterature": "Institute of Party History and Literature",
    "ceh": "China Economic Herald",
    "ctdnews": "China Trade News",
    "ChinaPostGroupCompanyLimited": "China Post",
    "zhongguohuanjingdaily": "China Environment News",
    "PowerConstructionCorporationOfChinaLTD": "Power Construction Corporation of China",
    "zgshb": "China Petrochemical News",
    "MinistryOfCivilAffairs": "China Ministry of Civil Affairs",
    "MinistryOfCommerce": "China Ministry of Commerce",
    "CentralCommissionForDisciplineInspection": "China Central Commission for Discipline Inspection",
    "zzyzb": "China Post News",
    "chinahightech": "China High-Tech Industry Herald",
    "zhongguoyiyaodaily": "China Pharmaceutical News",
    "StateAdministrationOfTraditionalChineseMedicine": "State Administration of Traditional Chinese Medicine",
    "gansudaily": "Gansu Daily",
    "MinistryOfVeternalAffaires": "Ministry of Veteran Affairs",
    "zhongguohangkongdaily": "China Aviation News",
    "MinistryOfFinance": "China Ministry of Finance",
    "NationalEthnicsAffairsCommission": "National Ethnics Affairs Commission of China",
    "MinistryOfIndustryAndInformationTechnology": "China Ministry of Industry and Information Technology",
    "NationalDevelopmentAndReformCommission": "National Development and Reform Commission of China",
    "MinistryOfForeignAffairs": "China Ministry of Foreign Affairs",
    "MinistryOfHumanResourcesAndSocialSecurity": "China Ministry of Human Resources and Social Security",
    "MinistryOfDefense": "China Ministry of Defense",
    "gongyishibao": "China Philanthropy News",
    "jjrb": "China Economic Daily",
    "shanxi2daily": "Shaanxi Daily",
    "zzdzb": "China Electronic News",
    "MinistryOfEcologyAndEnvironment": "China Ministry of Ecology and Environment",
    "InternationalDepartment": "International Department of CPC",
    "caacmedia": "CAAS News",
    "NationalEnergyAdministration": "National Energy Administration of China",
    "ChinaInspectionandCertificationGroup": "China Inspection and Certification Group",
    "StateAdministrationForMarketRegulation": "State Administration for Market Regulation of China",
    "ChinaAerospaceScienceAndTechnologyCorporation": "China Aerospace Science and Technology Corporation",
    "routeryun": "Labor Daily",
    "ChinaCivilizationNetwork": "China Civilization Network",
    "ChinaInternationalDevelopmentCooperationAgency": "China International Development Cooperation Agency",
    "zycg": "China Government Procurement Platform",
    "StateAdministrationOfForeignExchange": "China State Administration of Foreign Exchange",
    "TaiwanWorkOffice": "China Taiwan Work Office",
    "NationalIntellectualPropertyAdministration": "National Intellectual Property Administration of China",
    "MinistryOfEmergencyManagement": "China Ministry of Emergency Management",
    "AgriculturalDevelopmentBankofChina": "Agricultural Development Bank of China",
    "MinistryOfEducation": "China Ministry of Education",
    "CommissionForPoliticalAndLegalAffairs": "China Commission for Political and Legal Affairs",
    "zhongguojiaoshidaily": "China Teacher News",
    "StateAdministrationOfTaxation": "China State Administration of Taxation",
    "NationalNuclearSafetyAdministration": "National Nuclear Safety Administration of China",
    "zzzzrsb": "China Organization and Human Resources Post",
    "MinistryOfScienceAndTechnology": "China Ministry of Science and Technology",
    "NationalFoodAndStrategicReserveAdminstration": "National Food and Strategic Reserve Administration of China",
    "ChinaBuildingMaterialsGroupCoLtd": "China Building Materials Group",
    "ningxiadaily": "Ningxia Daily",
    "AluminumCorporationOfChinaLtd": "Aluminum Corporation of China",
    "ChinaPublishingGroupCoLTD": "China Publishing Group",
    "zzqyb": "China Enterprise Newspaper",
    "ChinaTelecom": "China Telecom",
    "zhongguokuangyedaily": "China Mining News",
    "NationalCultureHeritageAdministration": "National Culture Heritage Administration of China",
    "ChinaCoalGeologyAdministration": "China Coal Geology Administration",
    "zgqxb": "China Meteorological News",
    "ChinaNorthIndustriesGroupCorporationLimited": "China North Industries Group Corporation",
    "ChinaStateConstructionGroupCoLtd": "China State Construction Group",
    "DongfengMotorGroupCoLtd": "Dongfeng Motor Group",
    "CentralCommitteeOfTheCommunistPartyOfChina": "Central Committee of the Communist Party of China",
    "NationalEnergyGroup": "National Energy Group of China",
    "StateArchivesBureau": "State Archives Bureau of China",
    "ChinaEnergyConservationEnvironmentalProtectionGroupCoLtd": "China Energy Conservation Environmental Protection Group",
    "ChinaHuanengGroupCorporation": "China Huaneng Group Corporation",
    "HongKongAndMacauAffairsOffice": "Hong Kong and Macau Affairs Office of China",
    "ChinaChengtongHoldingGroupCoLtd": "China Chengtong Holding Group",
    "ChinaNationalRailwayGroupCorporationLTD": "China National Railway Group Corporation",
    "ChinaNationalOffshoreOilCorporationLTD": "China National Offshore Oil Corporation",
    "HarbinElectricGroupCoLtd": "Harbin Electric Group",
    "ChinaNanguangGroupCoLTD": "China Nanguang Group",
    "ChinaHuarongAssetManagementCoLtd": "China Huarong Asset Management",
    "ChinaInternationalTechnicalIntelligenceCoLTD": "China International Technical Intelligence",
    "BankofChinaCorporationLimited": "Bank of China",
    "MinistryOfNaturalResources": "China Ministry of Natural Resources",
    "ChinaGeneralNuclearPowerCorporationLtd": "China General Nuclear Power Corporation",
    "ChinaSaltIndustryGroupCoLtd": "China Salt Industry Group",
    "ChinaNationalPharmaceuticalGroupCoLtd": "China National Pharmaceutical Group",
    "CentralPeopleGovernmentOfThePeopleRepublicOfChina": "Central People's Government of China",
    "YouyanTechnologyGroupCoLtd": "Youyan Technology Group",
    "zhongguoshangbaodaily": "China Business Herald",
    "ChinaFirstHeavyGroupCoLtd": "China First Heavy Group",
    "ChinaDevelopmentBank": "China Development Bank",
    "BankingAndInsuranceRegulatoryCommission": "China Banking and Insurance Regulatory Commission",
    "CommercialAircraftCorporationChinaLtd": "Commercial Aircraft Corporation",
    "ChinaResourcesGroupCoLtd": "China Resources Group",
    "MinistryOfWaterResources": "China Ministry of Water Resources",
    "AuditOffice": "Audit Office of China",
    "TheUnitedFrontWorkDepartment": "United Front Work Department",
    "COFCOGroupCoLtd": "COFCO Group",
    "ChinaMerchantsGroup": "China Merchants Group",
    "cien": "China Industrial Economy News",
    "zhongguominzhudaily": "China Ethnic Affairs Post",
    "ChinaSecuritiesRegulatoryCommission": "China Securities Regulatory Commission",
    "GeneralAdministrationMetallurgicalGeologyChina": "China Metallurgical Geology Bureau",
    "MinistryOfTransport": "China Ministry of Transport",
    "OverseasChineseTownGroupCoLtd": "Overseas Chinese Town Group",
    "ChinaRailwaySignalCommunicationGroupCoLtd": "China Railway Signal Communication Group",
    "NationalGovernmentOfficesAdmin": "National Government Offices Administration of China",
    "PipelineChina": "National Pipeline Group",
    "StateSecrecyBureau": "National Administration of State Secrets Protection of China",
    "BankofCommunicationsCoLtd": "Bank of Communications",
    "ChinaTaipingInsuranceGroupCo": "China Taiping Insurance Group",
    "ChinaStateShipbuildingCorporation": "China State Shipbuilding Corporation",
    "StateAdministrationBureau": "China National Government Offices Administration",
    "ChinaGoldGroupCoLtd": "China Gold Group",
    "ChinaFAWGroupCoLtd": "China FAW Group",
    "zhongguohangtiandaily": "China Space News",
    "ChinaDevelopmentInvestmentGroupCoLtd": "China Development Investment Group",
    "ChinaNationalAviationGroupCoLTD": "China Natinal Aviation Group",
    "ChinaOceanShippingGroupCoLTD": "China Ocean Shipping Group",
    "ChinaLifeInsuranceGroupCorporation": "China Life Insurance Group",
    "ChinaGrainReservesManagementGroupCoLTD": "China Grain Reserves Management Group",
    "ChinaConstructionTechnologyCoLtd": "China Construction Technology",
    "AnshanIronSteelGroupCoLtd": "Anshan Iron Steel Group",
    "CentralGovernmentBondRegistrationClearingCoLtd": "China Central Depository & Clearing",
    "ChinaCoalTechnologyIndustryGroupCoLTD": "China Coal Technology & Engineering Group",
    "CounsellorOfficeAndCentralInstitueForCultureAndHistory": "China Counsellors' Office of the State Council",
    "ChinaPolyGroupCoLtd": "China Poly Group",
    "Pkulaw": "Peking University Law School",
    "ChinaOrientAssetManagementCoLtd": "China Orient Asset Management",
    "ChinaSinochemGroupCoLtd": "China Sinochem Group",
    "ChinaConstructionBankLTD": "China Construction Bank",
    "zhonghuadushudaily": "China Reading Weekly",
    "ChinaForestryGroupCoLtd": "China Forestry Group",
    "NationalImmigrationAdministration": "China National Immigration Administration",
    "xsdb": "Student Herald",
    "NationalPublicComplaintsAndProposalsAdministration": "National Public Complaints and Proposals Administration",
    "AgriculturalBankofChinaCoLtd": "Agricultural Bank of China",
    "ChinaRailwayRollingStockCorporationLtd": "China Railway Rolling Stock Corporation",
    "ChinaNationalTobaccoCorporation": "China National Tobacco Corporation",
    "NationalHealthcareSecurityAdministration": "China National Healthcare Security Administration",
    "ChinaTobacco": "China Tobacco",
    "cqnnews": "China Quality Daily",
    "ChinaCommunicationsConstructionGroupCoLtd": "China Communications Construction Group",
    "ChinaGreatWallAssetManagementCoLtd": "China Great Wall Asset Management",
    "StatePostBureau": "China State Post Bureau",
    "NationalCryptographyAdministration": "China National Cryptography Administration",
    "ChinaExportCreditInsuranceCorporation": "China Export Credit Insurance Corporation",
    "zhongguowenhuadaily": "China Culture Daily",
    "ChinaUnitedNetworkCommunicationsGroupCoLtd": "China United Network Communications Group",
    "ChinaGalaxyInvestmentManagementCoLtd": "China Galaxy Investment Management",
    "ChinaJianyinInvestmentcoLTD2": "China Jianyin Investment",
    "ChinaRailwayMaterialsGroupCoLtd": "China Railway Materials",
    "ChinaEverbrightGroupCorporation": "China Everbright Group",
    "ChinaDongfangElectricGroupCoLtd": "Dongfang Electric Corporation",
    "SinosteelGroupCoLTD": "Sinosteel",
    "ChinaInvestmentCorporationLimited": "China Investment Corporation",
    "ChinaCivilAviationInformationGroupCoLtd": "Civil Aviation Administration of China",
    "ChinaAeroEngineCorporation": "Aero Engine Corporation of China",
    "ChinaXDGroupCoLtd": "China XD Group",
    "StateForestryAndGrasslandAdministration": "State Forestry and Grassland Administration",
    "ChinaHuadianGroupCorporation": "China Huadian Corporation",
    "MiningMetallurgyTechnologyGroupCoLtd": "Mining Metallurgy Technology Group",
    "zhongguocaijingdaily": "China Financial and Economic News",
    "PeopleBankOfChina": "People's Bank of China",
    "ChinaCindaAssetManagementCoLtd": "China Cinda Asset Management",
    "ChinaNationalCoalGroupCoLTD": "China National Coal Group",
    "ChinaNationalMachineryIndustryGroupCoLtd": "China National Machinery Industry Group",
    "ChinaHualuGroupCoLTD": "China Hualu Group",
    "ChinaguoxinholdingcoLTD": "China Reform Holdings",
    "ChinaGalaxyFinancialHoldingCoLtd": "China Galaxy Financial Holding",
    "ChinaForeignCultureGroupCoLTD": "China Foreign Culture Group",
    "ChinaMinmetalsCorporationLTD": "China Minmetals Corporation",
    "CoalMineSafetySupervisionBureau": "Coal Mine Safety Supervision Bureau",
    "zhongguodianshidaily": "China Television News",
    "ChinaGeneralTechnologyCoLTD": "China General Technology",
    "nfrb": "Southern Daily",
    "StateAdministrationOfRadioAndTelevision": "State Administration of Radio and Television",
    "ChinaTourismGroupCoLtd": "China Tourism Group",
    "GeneralAdministrationOfSport": "General Administration of Sport",
    "MinistryOfJustice": "Ministry of Justice",
    "NationalRailwayAdministration": "National Railway Administration",
    "fzbnews": "Textiles Post",
    "zqrb": "Securities Daily",
    "cbmd": "China Building Materials News",
    "zhongguoshuiwu": "China Tax Newspaper",
    "hebeidaily": "Hebei Daily",
    "zhoudaosh": "Shanghai Morning Post",
    "yunnandaily": "Yunnan Daily",
    "StateCouncil2": "State Council Policy Library",
    "nanfangdaily": "Southern Daily",
    "zhongguolvseshi": "Green Times",
    "OfficeOfTheCentralCyberspaceAffairsCommission": "Central Cyberspace Affairs Commission",
    "zhongguodianyingdaily": "China Film News",
    "zhongguozhongyiyaodaily": "China News of Traditional Chinese Medicine",
    "MinistryOfHousingAndUrbanRuralDevelopment": "Ministry of Housing and Urban Rural Development",
    "ChinaNonferrousMiningGroupCoLtd": "China Nonferrous Mining Group",
    "ccgp_site_information": "Chinese Government Procurement Platform",
    "zhongguowenwudaily": "China Cultural Relics Information Network",
    "CECChinaElectronics": "China Electronics Corporation",
    "ChinaRailwayEngineeringGroupCoLtd": "China Railway Engineering Group",
    "ChinaReinsuranceCoLtd": "China Reinsurance",
    "ChinaPutianInformationIndustryGroupCoLtd": "China Putian Information Industry Group",
    "解放军报": "PLA Daily",
    "wangyi": "Wang Yi",
    "ChinaNationalChemicalCorporationLtd": "China National Chemical Corporation",
    "ChinaCITICGroupCoLtd": "CITIC Group",
    "ChinaSouthernPowerGrid": "China Southern Power Grid",
    "ChinaRadioAndTelevisionNetworkCoLTD": "China Radio and Television Network",
    "ExportImportBankofChina": "Export-Import Bank of China",
    "IndustrialCommercialBankofChinaCoLtd": "Industrial Commercial Bank of China",
    "ChinaAgriculturalDevelopmentGroupCoLtd": "China Agricultural Development Group",
    "PeopleInsuranceGroupCompanyOfChinaLimited": "People's Insurance Company of China",
    "ElectronicsTechnologyGroupCorporation": "Electronics Technology Group Corporation",
    # new
    "ChinaPetroleumNewsCenter": "China Petroleum News Center",
    "TheChinaNationalFarmersNewspaperAssociation": "The China National Farmers Newspaper Association",
    "ChinaNationalLightIndustryCouncil": "China National Light Industry Council",
    "ChinaAssociationDevelopmentZones": "China Association Development Zones",
    "ChinaBond": "China Bond",
    "ChinaPetroleumChemicalCorporation": "China Petroleum Chemical Corporation",
    "ChinaShipOwnersAssociation": "China Ship Owners Association",
    "中国邮政报": "China Post",
    "ChinaEnergyConstructionGroupCoLTD": "China Energy Construction Group",
    "ChinaGeneralMachineryIndustryAssociation": "China General Machinery Industry Association",
    "ChinaElectronicsEnterprisesAssociation": "China Electronics Enterprises Association",
    "ChinaPetroleumEnterpriseAssociation": "China Petroleum Enterprise Association",
    "ChineseEquestrianAssociation": "Chinese Equestrian Association",
    "ChinaElectronicComponentsAssociation": "China Electronic Components Association",
    "ChinaTrusteeAssociation": "China Trustee Association",
    "ChinaNuclearEnergyAssociation": "China Nuclear Energy Association",
    "ChinaElectricPowerConstructionAssociation": "China Electric Power Construction Association",
    "ChinaArchitecturalandIndustrialGlassAssociation": "China Architectureland Industrial Glass Association",
    "ChinaDatangGroupCorporation": "China Datang Group Corporation",
    "ChinaBooksellersandPublishersAssociation": "China Booksellersand Publishers Association",
    "ChinaCompositesIndustryAssociation": "China Composites Industry Association",
    "ChinaInformationIndustryAssociation": "China Information Industry Association",
    "ChinaBulkCementAssociationOfPopularizationDevelopment": "China Bulk Cement Association of Popularization Development",
    "ChinaElectricPowerPlanningEngineeringAssociation": "China Electric Power Planning Engineering Association",
    "ChineseInstituteOfCertifiedPublicAccountants": "Chinese Institute of Certified Public Accountants",
    "ChinaResourceCyclingAssociation": "China Resource Cycling Association",
    "ChinaCarbideIndustryAssociation": "China Carbide Industry Association",
    "ChinaBearingIndustryAssociation": "China Bearing Industry Association",
    "ChinaAssociationforCampusManagement": "China Associationfor Campus Management",
    "ChinaAssociationofNationalParkandScenicSites": "China Associationof National Parkand Scenic Sites",
    "ChinaSocietyofExplosivesandBlasting": "China Societyof Explosivesand Blasting",
    "ChineseAssociationforPeacefulUseofMilitaryIndustrialTechnology": "Chinese Associationfor Peaceful Useof Military Industrial Technology",
    "ChinaGoldAssociation": "China Gold Association",
    "ChinaElectricalEquipmentIndustryAssociation": "China Electrical Equipment Industry Association",
    "ChinaCommerceAssociationForGeneralMerchandise": "China Commerce Association for General Merchandise",
    "ChinaNationalBuildingWaterproofAssociation": "China National Building Waterproof Association",
    "ChinaSteelResearchTechnologyGroupCoLTD": "China Steel Research Technology Group CoLTD",
    "ChinaNationalCoalAssociation": "China National Coal Association",
    "NationalAssociationofFinancialMarketInstitutionalInvestors": "National Associationof Financial Market Institutional Investors",
    "ChinaAssociationofElectronicsEquipmentsForTechnologyDevelopment": "China Associationof Electronics Equipments for Technology Development",
    "AllChinaEnvironmentFederation": "All China Environment Federation",
    "ChinaChamberOfCommerceForMetallurgicalEnterprises": "China Chamber of Commerce for Metallurgical Enterprises",
    "ChinaAssociationforPromotingChildrensCultureandArt": "China Associationfor Promoting Childrens Cultureand Art",
    "ChineseCulturalInformationAssociation": "Chinese Cultural Information Association",
    "PaymentsandClearingAssociationofChina": "Paymentsand Clearing Associationof China",
    "ChinaNationalHardwareElectricandChemicalProductsCommercialAssociation": "China National Hardware Electricand Chemical Products Commercial Association",
    "TheRadioAssociationofChina": "The Radio Associationof China",
    "ChinaFinancingGuaranteeAssociation": "China Financing Guarantee Association",
    "ChinaSteelConstructionSociety": "China Steel Construction Society",
    "ChinaEntertainmentTechnologyAssociation": "China Entertainment Technology Association",
    "ChinaRoadSafetyAssociation": "China Road Safety Association",
    "ChinaAssociationofEngineeringConsultants": "China Associationof Engineering Consultants",
    "ChinaAssociationofSmallandMediumEnterprises": "China Associationof Smalland Medium Enterprises",
    "ChinaTallyAssociation": "China Tally Association",
    "ChinaSportingGoodsFederation": "China Sporting Goods Federation",
    "ChinaFuneralAssociation": "China Funeral Association",
    "ChinaInorganicSaltsIndustryAssociation": "China Inorganic Salts Industry Association",
    "ChinaCoalEducationAssociation": "China Coal Education Association",
    "ChinaDivingAndSalvageAssociation": "China Diving And Salvage Association",
    "ChineseMuseumsAssociation": "Chinese Museums Association",
    "ChinaNationalAssociationOfMetalMaterialTrade": "China National Association of Metal Material Trade",
    "ChinaAutoDealersChamberOfCommerce": "China Auto Dealers Chamber of Commerce",
    "ChinaAssociationForMechatronicsTechnologyandApplication": "China Association for Mechatronics Technologyand Application",
    "ChinaMedicinalBiotechnologyAssociation": "China Medicinal Biotechnology Association",
    "ChinaOccupationalSafetyandHealthAssociation": "China Occupational Safetyand Health Association",
    "ChineseEnterpriseSportsAssociation": "Chinese Enterprise Sports Association",
    "ChinaRubberIndustryAssociation": "China Rubber Industry Association",
    "ChinaInstrumentManufacturersAssociation": "China Instrument Manufacturers Association",
    "ChinaFuelCirculationAssociation": "China Fuel Circulation Association",
    "StatePowerNivestmentCorporation": "State Power Nivestment Corporation",
    "ChinaCertifiedTaxAgentsAssociation": "China Certified Tax Agents Association",
    "ChinaNationalTextileAndApparelCouncil": "China National Textile And Apparel Council",
    "ChinaFootballAssociation": "China Football Association",
    "ChinaFisheriesAssociation": "China Fisheries Association",
    "ChinaPetroleumCirculationAssociation": "China Petroleum Circulation Association",
    "ChinaAssociationofBuildingEnergyEfficiency": "China Associationof Building Energy Efficiency",
    "ChinaBatteryIndustryAssociation": "China Battery Industry Association",
    "ChinaMoney": "China Money",
    "ChinaSulphuricAcidIndustryAssociation": "China Sulphuric Acid Industry Association",
    "ChinaConstructionMachineryAssociation": "China Construction Machinery Association",
    "ChinaConcreteandCementbasedProductsAssociation": "China Concreteand Cementbased Products Association",
    "ChinaChainStoreFranchiseAssociation": "China Chain Store Franchise Association",
    "ChinaAssociationofCollectors": "China Associationof Collectors",
    "NMPA": "NMPA",
    "ChinaAnimalAgricultureAssociation": "China Animal Agriculture Association",
    "ChinaAggregateAssociation": "China Aggregate Association",
    "ChinaFoodandDrugCorporationQualityandSafetyPromotionAssociation": "China Foodand Drug Corporation Qualityand Safety Promotion Association",
    "ChineseVeterinaryMedicalAssociation": "Chinese Veterinary Medical Association",
    "FinanceCompanyAssociation": "Finance Company Association",
    "ChinaNationalCoatingsIndustryAssociation": "China National Coatings Industry Association",
    "ChinaIndustryNewsAssociation": "China Industry News Association",
    "ChinaBoilerandBoilerWaterTreatmentAssociation": "China Boilerand Boiler Water Treatment Association",
    "ChinaNationalPharmaceuticalPackagingAssociation": "China National Pharmaceutical Packaging Association",
    "ChinaConstructionManagementAssociation": "China Construction Management Association",
    "ChinaAssociationofCircularEconomy": "China Associationof Circular Economy",
    "ChinaAssociationofBusinessProfessionals": "China Associationof Business Professionals",
    "TheIndustryCleaningAssociationofChina": "The Industry Cleaning Associationof China",
    "ChinaSecuritiesAssociation": "China Securities Association",
    "ChinaKnittingIndustrialAssociation": "China Knitting Industrial Association",
    "ChinaUrbanHeatingAssociation": "China Urban Heating Association",
    "ChinaMaternalandChildHealthAssociation": "China Maternaland Child Health Association",
    "AllChinaPatentAttorneysAssociation": "All China Patent Attorneys Association",
    "ChinaEuropeAssociationForTechnicalAndEconomicCooperation": "China Europe Association for Technical And Economic Cooperation",
    "ChinaNationalFurnitureAssociation": "China National Furniture Association",
    "ChinaMeatAssociation": "China Meat Association",
    "ChinaChemicalIndustrialEquipmentAssociation": "China Chemical Industrial Equipment Association",
    "ChinaNitrogenFertilizerIndustryAssociation": "China Nitrogen Fertilizer Industry Association",
    "ChinaGolfAssociation": "China Golf Association",
    "ChinaFeatherDownIndustrialAssociation": "China Feather Down Industrial Association",
    "ChinaAssociationforthePromotionofInternationalAgriculturalCooperation": "China Association for the Promotionof International Agricultural Cooperation",
    "ChinaCondimentIndustrialAssociation": "China Condiment Industrial Association",
    "ChinaNationalAssociationOfGrainSector": "China National Association of Grain Sector",
    "ChinaCommunicationsStandardsAssociation": "China Communications Standards Association",
    "ChinaBuildingMaterialMachineryAssociation": "China Building Material Machinery Association",
    "ChinaHealthInspectionAssociation": "China Health Inspection Association",
    "ChinaAgriculturalAssociationforInternationalExchange": "China Agricultural Association for International Exchange",
    "ChinaSaltAssociation": "China Salt Association",
    "TheChineseWorkersTechnicalAssociation": "The Chinese Workers Technical Association",
    "ChinaAgriculturalMachineryDistributionAssociation": "China Agricultural Machinery Distribution Association",
    "ChinaOpticsandOptoelectronicsManufacturersAssociation": "China Optics and Optoelectronics Manufacturers Association",
    "ChinaGiftChamberofCommerce": "China Gift Chamber of Commerce",
    "ChinaCementAssociation": "China Cement Association",
    "ChinaCertificationandAccreditationAssociation": "China Certification and Accreditation Association",
    "PatentProtectionAssociationofChina": "Patent Protection Associationof China",
    "GNSSAndLBSAssociationofChina": "GNSS and LBS Association of China",
    "ChineseSocietyofBloodTransfusion": "Chinese Societyof Blood Transfusion",
    "ChinaPromotionAssociationforSpecialEquipmentSafetyandEnergysaving": "China Promotion Association for Special Equipment Safetyand Energysaving",
    "TrustAssociation": "Trust Association",
    "ChinaElectronicEnergySavingTechnologyAssociation": "China Electronic Energy Saving Technology Association",
    "ChinaQualityManagementAssociationForElectronicsIndustry": "China Quality Management Association for Electronics Industry",
    "ChinaSecurityAndProtectionIndustryAssociation": "China Security And Protection Industry Association",
    "ChinaConstructionIndustryAssociaion": "China Construction Industry Association",
    "ChinaAdhesivesandTapeIndustryAssociation": "China Adhesivesand Tape Industry Association",
    "ChinaCulturalIndustryAssociation": "China Cultural Industry Association",
    "ChinaPublicRelationsAssociation": "China Public Relations Association",
    "ChinaPetroleumPetrochemicalEquipmentIndustryAssociation": "China Petroleum Petrochemical Equipment Industry Association",
    "ChinaIndustryEnergyConservationAndCleanProductionAssociation": "China Industry Energy Conservation And Clean Production Association",
    "ChinaHighwayConstructionAssociation": "China Highway Construction Association",
    "ChinaInternationalChamberofCommerceforPrivateSector": "China International Chamberof Commerce for Private Sector",
    "ChinaMaritimePilotsAssociation": "China Maritime Pilots Association",
    "ChinaWaterTransportationConstructionAssociation": "China Water Transportation Construction Association",
    "ChinaNationalAssociationofFinanceCompanies": "China National Associationof Finance Companies",
    "ChinaNonwovensAndIndustrialTextilesAssociation": "China Nonwovens And Industrial Textiles Association",
    "SocialSportsInstructorAssociation": "Social Sports Instructor Association",
    "ChinaEnergyConservationAssociation": "China Energy Conservation Association",
    "AssetManagementAssociationofChina": "Asset Management Associationof China",
    "ChinaFederationOfIndustrialEconomics": "China Federation of Industrial Economics",
    "ChinaHeavyMachineryIndustryAssociation": "China Heavy Machinery Industry Association",
    "AssociationOfChinaRareEarthIndustry": "Association of China Rare Earth Industry",
    "ChineseAssociationofMineralResourcesAppraisers": "Chinese Association of Mineral Resources Appraisers",
    "ChinaRealEstateValuersandAgentsAssociation": "China Real Estate Valuersand Agents Association",
    "ChinaCommunicationsAndTransportationAssociation": "China Communications And Transportation Association",
    "ChinaHealthCareAssociation": "China Health Care Association",
    "ChinaAudioVideoCopyrightAssociation": "China Audio Video Copyright Association",
    "ChinaAssociationOfProductivityPromotionCenters": "China Association of Productivity Promotion Centers",
    "ChinaUsersAssociationforSatelliteCommunicationBroadcastingAndTelevision": "China Users Association for Satellite Communication Broadcasting And Television",
    "ChinaPetroleumChemicalEngineeringSurveyAndDesignAssociation": "China Petroleum Chemical Engineering Survey And Design Association",
    "ChinaGroupCompaniesAssociation": "China Group Companies Association",
    "InternetSocietyOfChina": "Internet Society of China",
    "ChinaBuildingMaterialsFederation": "China Building Materials Federation",
    "ChinaInternationalExchangeAndPromotiveAssociationForMedicalAndHealthCare": "China International Exchange And Promotive Association for Medical And Health Care",
    "ChinaElevatorAssociation": "China Elevator Association",
    "ChinaResaleGoodsTradingAssociation": "China Resale Goods Trading Association",
    "ChinaCommunicationsIndustryAssociation": "China Communications Industry Association",
    "ChinaHumicAcidIndustryAssociation": "China Humic Acid Industry Association",
    "ChinaXinhuaBookstoreAssociation": "China Xinhua Bookstore Association",
    "ChinaDredgingAssociation": "China Dredging Association",
    "ChinaMetallurgicalConstructionAssociation": "China Metallurgical Construction Association",
    "ChinaAssociationofConstructionEducation": "China Associationof Construction Education",
    "ChinaSchoolSportsFederation": "China School Sports Federation",
    "ChinaMicrocreditCompaniesAssociation": "China Microcredit Companies Association",
    "ChinaStoneMaterialAssociation": "China Stone Material Association",
    "ChinaAssociationforthePromotionofVillageDevelopment": "China Association for the Promotion of Village Development",
    "ChinaHealthPhotographersAssociation": "China Health Photographers Association",
    "ChinaCokingIndustryAssociation": "China Coking Industry Association",
    "ChinaWaterResourcesandElectricPowerAssociationOnPhysicalDistribution": "China Water Resources and Electric Power Association on Physical Distribution",
    "ChinaConstructionCultureandArtAssociation": "China Construction Cultureand Art Association",
    "InsuranceAssetManagementAssociationOfChina": "Insurance Asset Management Association of China",
    "EconomicMediaAssociationofChina": "Economic Media Association of China",
    "ChinaAssociationofChineseMedicine": "China Association of Chinese Medicine",
    "ChinaEducationalEquipmentIndustryAssociation": "China Educational Equipment Industry Association",
    "ChinaDieMouldIndustryAssociation": "China Die Mould Industry Association",
    "ChinaAssociationofPlantEngineeringConsultants": "China Association of Plant Engineering Consultants",
    "ChinaAfricaBusinessCouncil": "China Africa Business Council",
    "ChinaFruitMarketingAssociation": "China Fruit Marketing Association",
    "ChinaCoalTransportationandDistributionAssociation": "China Coal Transportationand Distribution Association",
    "ChinaDyeingandPrintingAssociation": "China Dyeing and Printing Association",
    "ChinaAssociationofRemoteSensingApplication": "China Association of Remote Sensing Application",
    "ChinaFederationOfUrbanCommercialOutletsConstructionAdministration": "China Federation of Urban Commercial Outlets Construction Administration",
    "PublisherAssociationOfChina": "Publisher Association of China",
    "ChinaUrbanWaterAssociation": "China Urban Water Association",
    "ChinaNonferrousMetalsConstructionAssociationAnc": "China Nonferrous Metals Construction Association",
    "ChinaNationalNarcoticDrugsAssociation": "China National Narcotic Drugs Association",
    "ChinaCostEngineeringAssociation": "China Cost Engineering Association",
    "ChinaBuildingDecorationAssociation": "China Building Decoration Association",
    "ChinaIndustrialAssociationofPowerSources": "China Industrial Association of Power Sources",
    "ChinaPharmaceuticalEnterprisesAssociation": "China Pharmaceutical Enterprises Association",
    "ChinaWaterEnterprisesConfederation": "China Water Enterprises Confederation",
    "ChinaChemicalFibersAssociation": "China Chemical Fibers Association",
    "ChinaAssociationforTechnicalSupervisionInformation": "China Association for Technical Supervision Information",
    "ChinaFolklorePhotographicAssociation": "China Folklore Photographic Association",
    "ChinaMaterialStorageTransportationAssociation": "China Material Storage Transportation Association",
    "ChinaAssociationForQuality": "China Association for Quality",
    "ChinaTechnicalAssociationonGeosynthetics": "China Technical Association on Geosynthetics",
    "ThePriceAssociationOfChina": "The Price Association of China",
    "ChinaAssociationForEngineeringConstructionStandardization": "China Association for Engineering Construction Standardization",
    "ChineseChemicalandPharmaceuticalEducationAssociation": "Chinese Chemical and Pharmaceutical Education Association",
    "ChinaYouthEntrepreneursAssociation": "China Youth Entrepreneurs Association",
    "ChinaAssociationforThePromotionofDevelopmentFinancing": "China Association for the Promotion of Development Financing",
    "ChinaChlorAlkaliIndustryAssociation": "China Chlor Alkali Industry Association",
    "ChinaCouncilforIndustrialEnvironmentalProtection": "China Council for Industrial Environmental Protection",
    "ChinaChamberOfCommerceImportExport": "China Chamber of Commerce Import Export",
    "ChinaAssociationOfSpecialEquipmentInspection": "China Association of Special Equipment Inspection",
    "ChinaEletricityTechnologyMarketAssociation": "China Electricity Technology Market Association",
    "ChinaMetalCuttingToolEngineeringAssociation": "China Metal Cutting Tool Engineering Association",
    "ChinaAgriculturalWholesaleMarketAssociation": "China Agricultural Wholesale Market Association",
    "ChinaLeasingAssociation": "China Leasing Association",
    "ChineseAgingWellAssociation": "Chinese Aging Well Association",
    "ChinaEducationInvestorsChamberofCommerce": "China Education Investors Chamber of Commerce",
    "ChinaFiberglassIndustryAssociation": "China Fiberglass Industry Association",
    "AutomaticIdentificationManufactureAssociationofChina": "Automatic Identification Manufacture Association of China",
    "ChinaCelluloseIndustryAssociation": "China Cellulose Industry Association",
    "ChinaEngineeringConstructionWeldingAssociation": "China Engineering Construction Welding Association",
    "ChinaEntryExitInspectionAndQuarantineAssociation": "China Entry Exit Inspection And Quarantine Association",
    "CivilAviationMaintenanceAssociationOfChina": "Civil Aviation Maintenance Association of China",
    "ChinaIsotopeAndRadiationAssociation": "China Isotope and Radiation Association",
    "ChinaCropProtectionIndustryAssociation": "China Crop Protection Industry Association",
    "ChineseHealthQigongAssociation": "Chinese Health Qigong Association",
    "ChinaChemicalMiningAssociation": "China Chemical Mining Association",
    "ChinaRuralHealthAssociation": "China Rural Health Association",
    "ChinaChamberOfCommerceForImportExportOfMachineryElectronicProducts": "China Chamber of Commerce for Import Export of Machinery Electronic Products",
    "ChinaAdvertisingAssociationofCommerce": "China Advertising Association of Commerce",
    "ChinaPharmaceuticalIndustryAssociation": "China Pharmaceutical Industry Association",
    "ChinaCottonTextileAssociation": "China Cotton Textile Association",
    "ChinaWrittenWorksCopyrightSociety": "China Written Works Copyright Society",
    "InternetAccessServiceAssociationOfChina": "Internet Access Service Association of China",
    "ChinaLogisticsTechnologyAssociation": "China Logistics Technology Association",
    "ChinaPeriodicalAssociation": "China Periodical Association",
    "ChinaPharmacistsAssociation": "China Pharmacists Association",
    "ChinaTrademarkAssociation": "China Trademark Association",
    "ChinaNationalSocietyforthePromotionofArtsandCulture": "China National Society of the Promotion of Arts and Culture",
    "ChinaChemicalEnergyConservationTechnologyAssociation": "China Chemical Energy Conservation Technology Association",
    "ChinaFederationofRadioandTelevisionAssociations": "China Federation of Radio and Television Associations",
    "ChineseCyclingAssociation": "Chinese Cycling Association",
    "AssociationForPromotionOfWestChinaResearchAndDevelopment": "Association for Promotion of West China Research and Development",
    "ChinaInformationCommunicationTechnologyGroupCoLTD": "China Information Communication Technology Group CoLTD",
    "ChinaPrintedCircuitAssociation": "China Printed Circuit Association",
    "ChinaPharmaceuticalAssociationofPlantEngineering": "China Pharmaceutical Association of Plant Engineering",
    "ChinaAssociationforGeospatialIndustryandSciences": "China Association for Geospatial Industry and Sciences",
    "ChinaAssociationofRehabilitationTechnologyTransformationandPromotion": "China Association of Rehabilitation Technology Transformationand Promotion",
    "ChinaConsultingAssociation": "China Consulting Association",
    "ChinaFederationofEconomicMedia": "China Federation of Economic Media",
    "ChinaHealthyBirthScienceAssociation": "China Healthy Birth Science Association",
    "ChinaHomeAssociation": "China Home Association",
    "ChinaAssociationForBarCodeTechnologyAndApplication": "China Association for Bar Code Technology and Application",
    "ChinaNaturalRubberAssociation": "China Natural Rubber Association",
    "ChinaOralCareIndustryAssociation": "China Oral Care Industry Association",
    "ChinaConstructionMaterialsRentalContractorAssociation": "China Construction Materials Rental Contractor Association",
    "ChineseAssociationofVacuumElectronicIndustry": "Chinese Association of Vacuum Electronic Industry",
    "ChinaEnvironmentChamberofCommerce": "China Environment Chamber of Commerce",
    "ChinaUrbantownizationPromotionCouncil": "China Urbantownization Promotion Council",
    "ChinaVeterinaryDrugAssociation": "China Veterinary Drug Association",
    "ChinaAssociationforPublicCompany": "China Association for Public Company",
    "ChinaAssociationofCommunicationEnterprises": "China Association of Communication Enterprises",
    "ChinaEducationAssociationofMachineryIndustry": "China Education Association of Machinery Industry",
    "CommunityHealthAssociationofChina": "Community Health Association of China",
    "ChinaNationalYouthPalaceAssociation": "China National Youth Palace Association",
    "ChinaIrrigationDistrictsAssociation": "China Irrigation Districts Association",
    "ChinaRopewayAssociation": "China Ropeway Association",
    "ChinaFrictionSealingMaterialAssociation": "China Friction Sealing Material Association",
    "ChinaWritingInstrumentAssociation": "China Writing Instrument Association",
    "ChinaNonFerrousMetalsIndustryAssociation": "China Non-Ferrous Metals Industry Association",
    "ChinaChemicalEnvironmentalProtectionAssociation": "China Chemical Environmental Protection Association",
    "ChinaGreenFoodAssociation": "China Green Food Association",
    "ChinaFederationOfIndustryAndCommerceOfAutoAndMotorbikePartsChamberOfCommerce": "China Federation of Industry and Commerce of Auto and Motorbike Parts Chamber of Commerce",
    "ChinaCreditGuaranteeCompanyAssociation": "China Credit Guarantee Company Association",
    "ChinaSodaIndustryAssociation": "China Soda Industry Association",
    "ChinaOptometricandOpticalAssociation": "China Optometricand Optical Association",
    "ChinaAssociationforPromotionofPrivateSciTechEnterprises": "China Association for Promotion of Private Science and Technology Enterprises",
    "ChinaInternationalCooperationAssociationofSmallandMediumEnterprises": "China International Cooperation Association of Small and Medium Enterprises",
    "ChinaInformationIndustryTradeAssociation": "China Information Industry Trade Association",
    "ChinaControlledChemicalsAssoication": "China Controlled Chemicals Assoication",
    "ChinaPhosphateandCompoundFertilizerIndustryAssociation": "China Photosynthesis and Compound Fertilizer Industry Association",
    "ChinaAsiaEconomicDevelopmentAssociation": "China Asia Economic Development Association",
    "ChinaCultureAdministrationAssociation": "China Culture Administration Association",
    "ChinaFisheryMutualInsuranceAssociation": "China Fishery Mutual Insurance Association",
}


def get_source_labels(
    sources: str | Iterable[str],
    *,
    when_not_found: Literal["preserve", "set_none", "set_unknown", "raise_error"] = "preserve",
    source_label_dict: dict = source_label_dict,
):
    """Get source labels for a source or list of source.

    Args:
        `source`: The list of inputs to get source labels for.
        `when_not_found`: The action to take when a source label is not found.
            - `"preserve"`: Preserve the source name as the source label.
            - `"set_none"`: Set the source label to None.
            - `"set_unknown"`: Set the source label to "unknown".
            - `"raise_error"`: Raise an error if a source label is not found.
        `source_label_dict`: A dictionary mapping source names to source labels.
        Set this value to override the default source label dictionary.

    Returns:
        A string or list of strings of source labels for the sources.

    Raises:
        ValueError: If the when_not_found value is not recognized.
        ValueError: If the source(s) are not a string or a string iterable.
        ValueError: If when_not_found is set to "raise_error" and a source label is not found.
    """

    if when_not_found not in [
        "preserve",
        "set_none",
        "set_unknown",
        "raise_error",
    ]:
        raise ValueError(f"Unknown label_when_not_found value: {when_not_found}")

    if not isinstance(sources, Iterable) and not isinstance(sources, str):
        raise TypeError(
            f"source(s) must be a string or string iterable but instead got: {type(sources).__name__}"
        )

    is_single_input = isinstance(sources, str)

    if is_single_input:
        sources = [sources]

    source_labels = []
    for source in sources:
        if source in source_label_dict:
            source_labels.append(source_label_dict[source])

        else:
            if when_not_found == "preserve":
                source_labels.append(source)

            elif when_not_found == "set_none":
                source_labels.append(None)

            elif when_not_found == "set_unknown":
                source_labels.append("unknown")

            elif when_not_found == "raise_error":
                raise ValueError(f"key '{source}' not found in dict")

    if is_single_input:
        return source_labels[0]

    return source_labels
